module Day4.Shared(
  section,
  elfPair,
  (+=+),
  Section,
  ElfPair
) where


import Data.Ranged
import Control.Lens

type Section = Range Int
type ElfPair = (Section, Section)

(+=+) :: Int -> Int -> Range Int
x +=+ y = Range (BoundaryBelow x) (BoundaryAbove y)

section :: String -> Section
section s = read start +=+ read end
  where
    (start, rest) = break ('-' ==) s
    end = drop 1 rest


elfPair :: String -> ElfPair
elfPair s = over each section (first, drop 1 second)
  where
    (first, second) = break (',' ==) s
