module Day7 (
  day7
) where

import Day7.Parser
import Day7.Interpreter
import Shared

day7 :: IO ()
day7 = do
   input <- readFile "ressources/day07-input"
   putStrLn "Day7"
   let parsed = forceRight $ parseTerminalLines input
   let tree = buildTree parsed
   let small = filterDirectories (<= 100000) tree
   let sumOfSmall = sum small
   putStrLn ("Sum of those directories is " ++ show sumOfSmall)
   let rootSize = head $ sizeOfDirectories tree
   let freeSpace = 70000000 - rootSize
   let requiredSpace = 30000000 - freeSpace
   let bigEnough = filterDirectories (>= requiredSpace) tree
   let smallest = minimum bigEnough
   putStrLn ("Smallest directory that is still large enough " ++ show smallest)

